//+------------------------------------------------------------------+
//|                                                  MA_Level_v2.mq4 |
//|                                                            Grell |
//|                                                dwgrell@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Grell"
#property link      "dwgrell@gmail.com"
#property indicator_separate_window //  
#property indicator_buffers 1 // 
#property indicator_color1 Red // 
// 
extern int       period=24;
extern int       method_ma=0;
extern int       ap_price=1;
//
double MA_L[];
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
int init()
  {
//
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,MA_L);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
int start()
  {
   if(method_ma>3 || method_ma<0)method_ma=0;
   if(ap_price>6 || ap_price<0)ap_price=1;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit-=1+period+1;

   for(int i=0; i<limit; i++)// 
     {
      MA_L[i]=0;
      for(int j=0;j<period;j++)// 
        {
         double ma0=iMA(NULL,0,period,0,method_ma,ap_price,i+j);// 
         double ma1=iMA(NULL,0,period,0,method_ma,ap_price,i+j+1);// 
         double open0=Open[i+j];//  
         double open1=Open[i+j+1];//  
         MA_L[i]+=Calc(ma0,ma1,open0,open1);
        }
      MA_L[i]=MA_L[i]/period;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int Calc(double ma0,double ma1,double open0,double open1)
  {
   if(ma0<open0 && ma0>ma1 && open0>open1)return(2);//  ,    
   if(ma0<open0 && ma0>ma1)return(1);//  , 
   if(ma0>ma1&&open0>open1)return(1);//    
   if(ma0>open0 && ma0<ma1 && open0<open1)return(-2);//  ,    
   if(ma0>open0 && ma0<ma1)return(-1);//  , 
   if(ma0<ma1&&open0<open1)return(-1);//    
   return(0);
  }
//+------------------------------------------------------------------+
